## libtoxcore 0.2.22

=== CMakeLists.txt ===
################################################################################
#
# The main toxcore CMake build file.
#
# This file when processed with cmake produces:
# - A number of small libraries (.a/.so/...) containing independent components
#   of toxcore. E.g. the DHT has its own library, and the system/network
#   abstractions are in their own library as well. These libraries are not
#   installed on `make install`. The toxav, and toxencryptsave libraries are
#   also not installed.
# - A number of small programs, statically linked if possible.
# - One big library containing all of the toxcore, toxav, and toxencryptsave
#   code.
#
################################################################################

cmake_minimum_required(VERSION 3.16)
cmake_policy(VERSION 3.16)
project(toxcore)

list(APPEND CMAKE_MODULE_PATH ${toxcore_SOURCE_DIR}/cmake)

option(FLAT_OUTPUT_STRUCTURE "Whether to produce output artifacts in ${CMAKE_BINARY_DIR}/{bin,lib}" OFF)
if(FLAT_OUTPUT_STRUCTURE)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
endif()

set_source_files_properties(
  toxcore/mono_time.c
  toxcore/os_event.c
  toxcore/os_network.c
  toxcore/tox.c
  toxcore/util.c
  PROPERTIES SKIP_UNITY_BUILD_INCLUSION TRUE)

################################################################################
#
# :: Version management
#
################################################################################

# This version is for the entire project. All libraries (core, av, ...) move in
# versions in a synchronised way.
set(PROJECT_VERSION_MAJOR "0")
set(PROJECT_VERSION_MINOR "2")
set(PROJECT_VERSION_PATCH "22")
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")

# set .so library version / following libtool scheme
# https://www.gnu.org/software/libtool/manual/libtool.html#Updating-version-info
file(STRINGS ${toxcore_SOURCE_DIR}/so.version SOVERSION_CURRENT REGEX "^CURRENT=[0-9]+$")
string(SUBSTRING "${SOVERSION_CURRENT}" 8 -1 SOVERSION_CURRENT)
file(STRINGS ${toxcore_SOURCE_DIR}/so.version SOVERSION_REVISION REGEX "^REVISION=[0-9]+$")
string(SUBSTRING "${SOVERSION_REVISION}" 9 -1 SOVERSION_REVISION)
file(STRINGS ${toxcore_SOURCE_DIR}/so.version SOVERSION_AGE REGEX "^AGE=[0-9]+$")
string(SUBSTRING "${SOVERSION_AGE}" 4 -1 SOVERSION_AGE)
# account for some libtool magic, see other/version-sync script for details
math(EXPR SOVERSION_MAJOR ${SOVERSION_CURRENT}-${SOVERSION_AGE})
set(SOVERSION "${SOVERSION_MAJOR}.${SOVERSION_AGE}.${SOVERSION_REVISION}")
message("SOVERSION: ${SOVERSION}")

################################################################################
#
# :: Dependencies and configuration
#
################################################################################

include(CTest)
include(ModulePackage)
include(StrictAbi)
include(GNUInstallDirs)
include(CheckIncludeFile)
include(CheckSymbolExists)

if(APPLE)
  include(MacRpath)
endif()

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
  check_include_file(sys/epoll.h HAVE_SYS_EPOLL_H)
  if(HAVE_SYS_EPOLL_H)
    check_symbol_exists(epoll_create "sys/epoll.h" HAVE_EPOLL_CREATE)
    if(HAVE_EPOLL_CREATE)
      add_definitions(-DEV_USE_EPOLL=1)
      add_definitions(-DTCP_SERVER_USE_EPOLL=1)
    endif()
  endif()
endif()

enable_testing()
find_package(GTest)
find_package(benchmark QUIET)

set(CMAKE_MACOSX_RPATH ON)

# Set standard version for compiler.
if(MSVC AND MSVC_TOOLSET_VERSION LESS 143)
  # https://developercommunity.visualstudio.com/t/older-winsdk-headers-are-incompatible-with-zcprepr/1593479
  set(CMAKE_C_STANDARD 99)
else()
  set(CMAKE_C_STANDARD 11)
endif()
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_C_EXTENSIONS OFF)
set(CMAKE_CXX_EXTENSIONS OFF)

message(STATUS "Supported C compiler features = ${CMAKE_C_COMPILE_FEATURES}")
message(STATUS "Supported C++ compiler features = ${CMAKE_CXX_COMPILE_FEATURES}")

# Enable some warnings if we know the compiler.
if(MSVC)
  add_compile_options(/W4 /analyze)
  add_compile_options(/wd4100)  # unreferenced formal parameter
  add_compile_options(/wd4267)  # narrowing conversion
  add_compile_options(/wd4244)  # narrowing conversion
  add_compile_options(/wd4127)  # conditional expression is constant
  add_compile_options(/wd4995)  # #pragma deprecated
  add_compile_options(/wd4018)  # signed/unsigned compare
  add_compile_options(/wd4310)  # cast truncates constant value
  add_compile_options(/wd4389)  # signed/unsigned compare
  add_compile_options(/wd4245)  # signed/unsigned assign/return/function call
  add_compile_options(/wd4200)  # nonstandard extension used: zero-sized array in struct/union
  add_compile_options(/wd4702)  # unreachable code
  add_compile_options(/wd6340)  # unsigned int passed to signed parameter
  add_compile_options(/wd6326)  # potential comparison of a constant with another constant

  # TODO(iphydf): Look into these
  add_compile_options(/wd4996)  # use WSAAddressToStringW() instead of WSAAddressToStringA()
  add_compile_options(/wd6255)  # don't use alloca
  add_compile_options(/wd6385)  # reading invalid data
  add_compile_options(/wd6001)  # using uninitialized memory
  add_compile_options(/wd6101)  # returning uninitialized memory
  add_compile_options(/wd6386)  # buffer overrun
  add_compile_options(/wd6011)  # NULL dereference
  add_compile_options(/wd6031)  # sscanf return value ignored
  add_compile_options(/wd6387)  # passing NULL to fwrite
endif()

set(MIN_LOGGER_LEVEL "" CACHE STRING "Logging level to use (TRACE, DEBUG, INFO, WARNING, ERROR)")
if(MIN_LOGGER_LEVEL)
  if(("${MIN_LOGGER_LEVEL}" STREQUAL "TRACE") OR
     ("${MIN_LOGGER_LEVEL}" STREQUAL "DEBUG") OR
     ("${MIN_LOGGER_LEVEL}" STREQUAL "INFO") OR
     ("${MIN_LOGGER_LEVEL}" STREQUAL "WARNING") OR
     ("${MIN_LOGGER_LEVEL}" STREQUAL "ERROR"))
    add_definitions(-DMIN_LOGGER_LEVEL=LOGGER_LEVEL_${MIN_LOGGER_LEVEL})
  else()
    message(FATAL_ERROR "Unknown value provided for MIN_LOGGER_LEVEL: \"${MIN_LOGGER_LEVEL}\", must be one of TRACE, DEBUG, INFO, WARNING or ERROR")
  endif()
endif()

option(EXPERIMENTAL_API "Install experimental header file with unstable API" OFF)

option(USE_IPV6 "Use IPv6 in tests" ON)
if(NOT USE_IPV6)
  add_definitions(-DUSE_IPV6=0)
endif()

option(BUILD_MISC_TESTS "Build additional tests" OFF)
option(BUILD_FUN_UTILS "Build additional just for fun utilities" OFF)

option(UNITTEST "Enable unit tests (disable if you don't have a working gmock or gtest)" ON)

option(AUTOTEST "Enable autotests (mainly for CI)" OFF)
if(AUTOTEST)
  option(NON_HERMETIC_TESTS "Whether to build and run tests that depend on an internet connection" OFF)
  option(PROXY_TEST "Enable proxy test (requires other/proxy/proxy_server.go to be running)" OFF)
endif()

option(BUILD_TOXAV "Whether to build the tox AV library" ON)
option(MUST_BUILD_TOXAV "Fail the build if toxav cannot be built" OFF)

option(DHT_BOOTSTRAP "Enable building of DHT_bootstrap" ON)
option(BOOTSTRAP_DAEMON "Enable building of tox-bootstrapd" ON)
if(BOOTSTRAP_DAEMON AND WIN32)
  message(WARNING "Building tox-bootstrapd for Windows is not supported, disabling")
  set(BOOTSTRAP_DAEMON OFF CACHE BOOL "" FORCE)
endif()

option(BUILD_FUZZ_TESTS "Build fuzzing harnesses" OFF)

if(MSVC)
  option(MSVC_STATIC_SODIUM "Whether to link libsodium statically for MSVC" OFF)
  if(MSVC_STATIC_SODIUM)
    add_definitions(-DSODIUM_STATIC=1)
  endif()
endif()

include(Dependencies)

if(MUST_BUILD_TOXAV)
  set(NO_TOXAV_ERROR_TYPE SEND_ERROR)
  set(BUILD_TOXAV ON CACHE BOOL "" FORCE)
else()
  set(NO_TOXAV_ERROR_TYPE WARNING)
endif()

if(BUILD_TOXAV)
  if(NOT OPUS_FOUND)
    message(${NO_TOXAV_ERROR_TYPE} "Option BUILD_TOXAV is enabled but required library OPUS was not found.")
    set(BUILD_TOXAV OFF CACHE BOOL "" FORCE)
  endif()
  if(NOT VPX_FOUND)
    message(${NO_TOXAV_ERROR_TYPE} "Option BUILD_TOXAV is enabled but required library VPX was not found.")
    set(BUILD_TOXAV OFF CACHE BOOL "" FORCE)
  endif()
endif()

# Disable float/double packing in CMP (C MessagePack library).
# We don't transfer floats over the network, so we disable this functionality.
add_definitions(-DCMP_NO_FLOAT=1)

################################################################################
#
# :: Tox Core Library
#
################################################################################

# toxcore_PKGCONFIG_LIBS is what's added to the Libs: line in toxcore.pc. It
# needs to contain all the libraries a program using toxcore should link against
# if it's statically linked. If it's dynamically linked, there is no need to
# explicitly link against all the dependencies, but it doesn't harm much(*)
# either.
#
# (*) It allows client code to use symbols from our dependencies without
#    explicitly linking against them.
set(toxcore_PKGCONFIG_LIBS)
# Requires: in pkg-config file.
set(toxcore_PKGCONFIG_REQUIRES)

set(toxcore_SOURCES
  third_party/cmp/cmp.c
  third_party/cmp/cmp.h
  toxcore/announce.c
  toxcore/announce.h
  toxcore/bin_pack.c
  toxcore/bin_pack.h
  toxcore/bin_unpack.c
  toxcore/bin_unpack.h
  toxcore/ccompat.c
  toxcore/ccompat.h
  toxcore/crypto_core.c
  toxcore/crypto_core.h
  toxcore/crypto_core_pack.c
  toxcore/crypto_core_pack.h
  toxcore/DHT.c
  toxcore/DHT.h
  toxcore/ev.c
  toxcore/ev.h
  toxcore/events/conference_connected.c
  toxcore/events/conference_invite.c
  toxcore/events/conference_message.c
  toxcore/events/conference_peer_list_changed.c
  toxcore/events/conference_peer_name.c
  toxcore/events/conference_title.c
  toxcore/events/dht_nodes_response.c
  toxcore/events/events_alloc.c
  toxcore/events/events_alloc.h
  toxcore/events/file_chunk_request.c
  toxcore/events/file_recv.c
  toxcore/events/file_recv_chunk.c
  toxcore/events/file_recv_control.c
  toxcore/events/friend_connection_status.c
  toxcore/events/friend_lossless_packet.c
  toxcore/events/friend_lossy_packet.c
  toxcore/events/friend_message.c
  toxcore/events/friend_name.c
  toxcore/events/friend_read_receipt.c
  toxcore/events/friend_request.c
  toxcore/events/friend_status.c
  toxcore/events/friend_status_message.c
  toxcore/events/friend_typing.c
  toxcore/events/self_connection_status.c
  toxcore/events/group_custom_packet.c
  toxcore/events/group_custom_private_packet.c
  toxcore/events/group_invite.c
  toxcore/events/group_join_fail.c
  toxcore/events/group_message.c
  toxcore/events/group_moderation.c
  toxcore/events/group_password.c
  toxcore/events/group_peer_exit.c
  toxcore/events/group_peer_join.c
  toxcore/events/group_peer_limit.c
  toxcore/events/group_peer_name.c
  toxcore/events/group_peer_status.c
  toxcore/events/group_privacy_state.c
  toxcore/events/group_private_message.c
  toxcore/events/group_self_join.c
  toxcore/events/group_topic.c
  toxcore/events/group_topic_lock.c
  toxcore/events/group_voice_state.c
  toxcore/forwarding.c
  toxcore/forwarding.h
  toxcore/friend_connection.c
  toxcore/friend_connection.h
  toxcore/friend_requests.c
  toxcore/friend_requests.h
  toxcore/group.c
  toxcore/group_chats.c
  toxcore/group_chats.h
  toxcore/group_common.h
  toxcore/group_connection.c
  toxcore/group_connection.h
  toxcore/group.h
  toxcore/group_announce.c
  toxcore/group_announce.h
  toxcore/group_moderation.c
  toxcore/group_moderation.h
  toxcore/group_onion_announce.c
  toxcore/group_onion_announce.h
  toxcore/group_pack.c
  toxcore/group_pack.h
  toxcore/LAN_discovery.c
  toxcore/LAN_discovery.h
  toxcore/list.c
  toxcore/list.h
  toxcore/logger.c
  toxcore/logger.h
  toxcore/Messenger.c
  toxcore/Messenger.h
  toxcore/mem.c
  toxcore/mem.h
  toxcore/mono_time.c
  toxcore/mono_time.h
  toxcore/net.c
  toxcore/net.h
  toxcore/net_crypto.c
  toxcore/net_crypto.h
  toxcore/net_log.c
  toxcore/net_log.h
  toxcore/net_profile.c
  toxcore/net_profile.h
  toxcore/network.c
  toxcore/network.h
  toxcore/onion_announce.c
  toxcore/onion_announce.h
  toxcore/onion.c

=== auto_tests/CMakeLists.txt ===
set(TEST_TIMEOUT_SECONDS "" CACHE STRING "Limit runtime of each test to the number of seconds specified")

add_library(auto_test_support
  auto_test_support.c
  auto_test_support.h)
target_link_libraries(auto_test_support PRIVATE misc_tools)
if(TARGET toxcore_static)
  target_link_libraries(auto_test_support PRIVATE toxcore_static)
else()
  target_link_libraries(auto_test_support PRIVATE toxcore_shared)
endif()
if(TARGET pthreads4w::pthreads4w)
  target_link_libraries(auto_test_support PRIVATE pthreads4w::pthreads4w)
elseif(TARGET PThreads4W::PThreads4W)
  target_link_libraries(auto_test_support PRIVATE PThreads4W::PThreads4W)
elseif(TARGET Threads::Threads)
  target_link_libraries(auto_test_support PRIVATE Threads::Threads)
endif()

function(auto_test target)
  add_executable(auto_${target}_test ${target}_test.c)
  target_link_libraries(auto_${target}_test PRIVATE misc_tools auto_test_support)
  if(TARGET toxcore_static)
    target_link_libraries(auto_${target}_test PRIVATE toxcore_static)
  else()
    target_link_libraries(auto_${target}_test PRIVATE toxcore_shared)
  endif()
  if(TARGET pthreads4w::pthreads4w)
    target_link_libraries(auto_${target}_test PRIVATE pthreads4w::pthreads4w)
  elseif(TARGET PThreads4W::PThreads4W)
    target_link_libraries(auto_${target}_test PRIVATE PThreads4W::PThreads4W)
  elseif(TARGET Threads::Threads)
    target_link_libraries(auto_${target}_test PRIVATE Threads::Threads)
  endif()
  add_test(NAME ${target} COMMAND auto_${target}_test)
  set_tests_properties(${target} PROPERTIES TIMEOUT "${TEST_TIMEOUT_SECONDS}")
  # add the source dir as environment variable, so the testdata can be found
  set_tests_properties(${target} PROPERTIES ENVIRONMENT "LLVM_PROFILE_FILE=${target}.profraw;srcdir=${CMAKE_CURRENT_SOURCE_DIR}")
endfunction()

auto_test(TCP)
auto_test(announce)
auto_test(crypto)
#auto_test(dht)  # Doesn't work with UNITY_BUILD.
auto_test(encryptsave)
auto_test(file_saving)
auto_test(forwarding)
auto_test(invalid_tcp_proxy)
auto_test(invalid_udp_proxy)
auto_test(network)
auto_test(onion)
auto_test(save_compatibility)
auto_test(tox_dispatch)
auto_test(tox_new)
auto_test(tox_strncasecmp)
auto_test(version)

add_subdirectory(scenarios)

target_include_directories(auto_encryptsave_test SYSTEM PRIVATE ${LIBSODIUM_INCLUDE_DIRS})

if(NON_HERMETIC_TESTS)
  auto_test(tcp_relay)
endif()

if(PROXY_TEST)
  auto_test(proxy)
endif()

=== testing/CMakeLists.txt ===
# Helpful code for tests and other utilities
set(misc_tools_SOURCES
  misc_tools.c
  misc_tools.h)
add_library(misc_tools STATIC ${misc_tools_SOURCES})
if(TARGET toxcore_static)
  target_link_libraries(misc_tools PRIVATE toxcore_static)
else()
  target_link_libraries(misc_tools PRIVATE toxcore_shared)
endif()
if(TARGET pthreads4w::pthreads4w)
  target_link_libraries(misc_tools PUBLIC pthreads4w::pthreads4w)
elseif(TARGET PThreads4W::PThreads4W)
  target_link_libraries(misc_tools PUBLIC PThreads4W::PThreads4W)
elseif(TARGET Threads::Threads)
  target_link_libraries(misc_tools PUBLIC Threads::Threads)
endif()

################################################################################
#
# :: Test programs
#
################################################################################

if(BUILD_MISC_TESTS)
  add_executable(Messenger_test Messenger_test.c)
  target_link_libraries(Messenger_test PRIVATE misc_tools)
  if(TARGET toxcore_static)
    target_link_libraries(Messenger_test PRIVATE toxcore_static)
  else()
    target_link_libraries(Messenger_test PRIVATE toxcore_shared)
  endif()
endif()

if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/bench")
  add_subdirectory(bench)
endif()

if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/support")
  add_subdirectory(support)
endif()

=== auto_tests/scenarios/CMakeLists.txt ===
add_library(scenario_framework
  framework/framework.c
  framework/framework.h)
target_link_libraries(scenario_framework PUBLIC misc_tools)
if(TARGET toxcore_static)
  target_link_libraries(scenario_framework PUBLIC toxcore_static)
else()
  target_link_libraries(scenario_framework PUBLIC toxcore_shared)
endif()
if(TARGET pthreads4w::pthreads4w)
  target_link_libraries(scenario_framework PUBLIC pthreads4w::pthreads4w)
elseif(TARGET PThreads4W::PThreads4W)
  target_link_libraries(scenario_framework PUBLIC PThreads4W::PThreads4W)
elseif(TARGET Threads::Threads)
  target_link_libraries(scenario_framework PUBLIC Threads::Threads)
endif()

function(scenario_test target)
  add_executable(auto_${target}_test ${target}_test.c)
  target_link_libraries(auto_${target}_test PRIVATE misc_tools scenario_framework)
  add_test(NAME ${target} COMMAND auto_${target}_test)
  set_tests_properties(${target} PROPERTIES TIMEOUT "${TEST_TIMEOUT_SECONDS}")
  # add the source dir as environment variable, so the testdata can be found
  set_tests_properties(${target} PROPERTIES ENVIRONMENT "LLVM_PROFILE_FILE=${target}.profraw;srcdir=${CMAKE_CURRENT_SOURCE_DIR}/..")
endfunction()

scenario_test(scenario_avatar)
scenario_test(scenario_bootstrap)
scenario_test(scenario_conference)
scenario_test(scenario_conference_double_invite)
scenario_test(scenario_conference_invite_merge)
scenario_test(scenario_conference_offline)
scenario_test(scenario_conference_peer_nick)
scenario_test(scenario_conference_query)
scenario_test(scenario_conference_simple)
scenario_test(scenario_conference_two)
scenario_test(scenario_dht_nodes_response_api)
scenario_test(scenario_events)
scenario_test(scenario_file_cancel)
scenario_test(scenario_file_seek)
scenario_test(scenario_file_transfer)
scenario_test(scenario_friend_connection)
scenario_test(scenario_friend_delete)
scenario_test(scenario_friend_query)
scenario_test(scenario_friend_read_receipt)
scenario_test(scenario_friend_request)
scenario_test(scenario_friend_request_spam)
scenario_test(scenario_group_by_id)
scenario_test(scenario_group_general)
scenario_test(scenario_group_invite)
scenario_test(scenario_group_message)
scenario_test(scenario_group_moderation)
scenario_test(scenario_group_save)
scenario_test(scenario_group_state)
scenario_test(scenario_group_sync)
scenario_test(scenario_group_tcp)
scenario_test(scenario_group_topic)
scenario_test(scenario_lan_discovery)
scenario_test(scenario_lossless_packet)
scenario_test(scenario_lossy_packet)
scenario_test(scenario_message)
scenario_test(scenario_netprof)
scenario_test(scenario_nospam)
scenario_test(scenario_overflow_recvq)
scenario_test(scenario_overflow_sendq)
scenario_test(scenario_reconnect)
scenario_test(scenario_save_friend)
scenario_test(scenario_save_load)
scenario_test(scenario_self_query)
scenario_test(scenario_send_message)
scenario_test(scenario_set_name)
scenario_test(scenario_set_status_message)
scenario_test(scenario_tox_many)
scenario_test(scenario_tox_many_tcp)
scenario_test(scenario_typing)
scenario_test(scenario_user_status)

if(BUILD_TOXAV)
  scenario_test(scenario_toxav_basic)
  scenario_test(scenario_toxav_many)
  scenario_test(scenario_conference_av)

  if(TARGET libvpx::libvpx)
    target_link_libraries(auto_scenario_toxav_basic_test PRIVATE libvpx::libvpx)
    target_link_libraries(auto_scenario_toxav_many_test PRIVATE libvpx::libvpx)
  elseif(TARGET PkgConfig::VPX)
    target_link_libraries(auto_scenario_toxav_basic_test PRIVATE PkgConfig::VPX)
    target_link_libraries(auto_scenario_toxav_many_test PRIVATE PkgConfig::VPX)
  else()
    target_link_libraries(auto_scenario_toxav_basic_test PRIVATE ${VPX_LIBRARIES})
    target_link_directories(auto_scenario_toxav_basic_test PRIVATE ${VPX_LIBRARY_DIRS})
    target_include_directories(auto_scenario_toxav_basic_test SYSTEM PRIVATE ${VPX_INCLUDE_DIRS})
    target_compile_options(auto_scenario_toxav_basic_test PRIVATE ${VPX_CFLAGS_OTHER})

    target_link_libraries(auto_scenario_toxav_many_test PRIVATE ${VPX_LIBRARIES})
    target_link_directories(auto_scenario_toxav_many_test PRIVATE ${VPX_LIBRARY_DIRS})
    target_include_directories(auto_scenario_toxav_many_test SYSTEM PRIVATE ${VPX_INCLUDE_DIRS})
    target_compile_options(auto_scenario_toxav_many_test PRIVATE ${VPX_CFLAGS_OTHER})
  endif()
endif()

=== testing/bench/CMakeLists.txt ===
if(NOT UNITTEST)
  return()
endif()

find_package(benchmark QUIET)

if(benchmark_FOUND)
  add_executable(tox_messenger_bench tox_messenger_bench.cc)
  target_link_libraries(tox_messenger_bench PRIVATE
    toxcore_static
    support
    benchmark::benchmark
  )

  add_executable(tox_friends_scaling_bench tox_friends_scaling_bench.cc)
  target_link_libraries(tox_friends_scaling_bench PRIVATE
    toxcore_static
    support
    benchmark::benchmark
  )
endif()

=== testing/fuzzing/CMakeLists.txt ===
# Override network and random functions

set(LIBFUZZER_LINKER_FLAGS)
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  set(LIBFUZZER_LINKER_FLAGS "-fsanitize=fuzzer")
else()
  message(SEND_ERROR "Compiler must be Clang to build fuzz targets")
endif()

function(fuzz_test target source_dir)
  set(CORPUS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/toktok-fuzzer/corpus/${target}_fuzz_test)
  file(GLOB CORPUS "${CORPUS_DIR}/*")
  add_executable(${target}_fuzz_test ${source_dir}/${target}_fuzz_test.cc)
  target_link_libraries(${target}_fuzz_test PRIVATE support test_util toxcore_fuzz ${LIBFUZZER_LINKER_FLAGS})
  if(CORPUS)
    add_test(NAME ${target}_fuzz COMMAND ${target}_fuzz_test -max_total_time=10 ${CORPUS})
    set_property(TEST ${target}_fuzz PROPERTY ENVIRONMENT "LLVM_PROFILE_FILE=${target}.profraw;srcdir=${CMAKE_CURRENT_SOURCE_DIR}")
  endif()
endfunction()

fuzz_test(bootstrap        .)  # Fuzzes the bootstrap process
# TODO(iphydf): Fix this in the cmake build.
# fuzz_test(e2e              .)  # Fuzzes an end-to-end connection
fuzz_test(toxsave          .)  # Fuzzes tox_new and tox_get_savedata

fuzz_test(DHT              ../../toxcore)
fuzz_test(forwarding       ../../toxcore)
fuzz_test(group_announce   ../../toxcore)
fuzz_test(group_moderation ../../toxcore)
fuzz_test(net_crypto       ../../toxcore)
fuzz_test(tox_events       ../../toxcore)

=== testing/support/CMakeLists.txt ===
if(NOT UNITTEST)
  return()
endif()

set(support_SOURCES
  doubles/fake_network_stack.cc
  doubles/fake_sockets.cc
  doubles/network_universe.cc
  src/clock.cc
  src/environment.cc
  src/fake_clock.cc
  src/fake_memory.cc
  src/fake_random.cc
  src/fuzz_helpers.cc
  src/memory.cc
  src/network.cc
  src/random.cc
  src/simulated_environment.cc
  src/simulation.cc
  src/tox_network.cc
  src/tox_runner.cc
  doubles/fake_clock.hh
  doubles/fake_memory.hh
  doubles/fake_network_stack.hh
  doubles/fake_random.hh
  doubles/fake_sockets.hh
  doubles/network_universe.hh
  public/clock.hh
  public/environment.hh
  public/fuzz_data.hh
  public/fuzz_helpers.hh
  public/memory.hh
  public/mpsc_queue.hh
  public/network.hh
  public/random.hh
  public/simulated_environment.hh
  public/simulation.hh
  public/tox_network.hh
  public/tox_runner.hh
)

add_library(support STATIC ${support_SOURCES})

if(TARGET toxcore_static)
  target_link_libraries(support PRIVATE toxcore_static)
else()
  target_link_libraries(support PRIVATE toxcore_shared)
endif()

if(TARGET pthreads4w::pthreads4w)
  target_link_libraries(support PUBLIC pthreads4w::pthreads4w)
elseif(TARGET PThreads4W::PThreads4W)
  target_link_libraries(support PUBLIC PThreads4W::PThreads4W)
elseif(TARGET Threads::Threads)
  target_link_libraries(support PUBLIC Threads::Threads)
endif()

if(TARGET GTest::gtest_main)
  function(support_test target source)
    add_executable(${target} ${source})
    target_link_libraries(${target} PRIVATE support GTest::gtest_main)
    if(TARGET toxcore_static)
      target_link_libraries(${target} PRIVATE toxcore_static)
    else()
      target_link_libraries(${target} PRIVATE toxcore_shared)
    endif()
    add_test(NAME ${target} COMMAND ${target})
  endfunction()

  support_test(fake_sockets_test doubles/fake_sockets_test.cc)
  support_test(fake_network_stack_test doubles/fake_network_stack_test.cc)
  support_test(fake_network_udp_test doubles/fake_network_udp_test.cc)
  support_test(fake_network_tcp_test doubles/fake_network_tcp_test.cc)
  support_test(network_universe_test doubles/network_universe_test.cc)
  support_test(bootstrap_scaling_test bootstrap_scaling_test.cc)
  # TODO(iphydf): Re-enable once we migrate TCP server to ev.
  #support_test(tox_network_test tox_network_test.cc)
endif()

=== other/deploy/single-file/Makefile ===
TARGETS = libtoxcore.a libtoxcore-minimal.a

all: $(TARGETS)

libtoxcore.o: $(wildcard toxcore-*av.c)
	$(CC) -c -o $@ $< \
		-O2 \
		-Wno-discarded-qualifiers \
		-fPIC \
		-Wl,-Bstatic \
		$(shell pkg-config --cflags --libs libsodium) \
		-Wl,-Bdynamic \
		$(shell pkg-config --cflags --libs opus vpx) \
		-pthread

libtoxcore-minimal.o: $(wildcard toxcore-*core.c)
	$(CC) -c -o $@ $< \
		-O2 \
		-Wno-discarded-qualifiers \
		-fPIC \
		-Wl,-Bstatic \
		$(shell pkg-config --cflags --libs libsodium) \
		-pthread

%.a: %.o
	$(AR) rcs $@ $^

=== other/docker/compcert/Makefile ===
CC := ccomp
CFLAGS := -Wall \
	  -Wno-c11-extensions \
	  -Wno-unknown-pragmas \
	  -Wno-unused-variable \
	  -fstruct-passing -fno-unprototyped -g \
	  -Ilibsodium/src/libsodium/include \
	  $(shell pkg-config --cflags opus vpx)
LDFLAGS := -lpthread $(shell pkg-config --libs opus vpx)

libsodium_SOURCES := $(shell find libsodium/src/libsodium -name "*.c")
libsodium_OBJECTS := $(libsodium_SOURCES:.c=.o)

$(libsodium_OBJECTS): CFLAGS += \
	-DDEV_MODE \
	-DCONFIGURED \
	-D_DEFAULT_SOURCE \
	-Ilibsodium/builds/msvc \
	-Ilibsodium/src/libsodium/include/sodium

toxcore_SOURCES := $(wildcard \
	   auto_tests/scenarios/framework/framework.c \
	   auto_tests/scenarios/scenario_send_message_test.c \
	   testing/misc_tools.c \
	   toxav/*.c \
	   toxcore/*.c \
	   toxcore/*/*.c \
	   toxencryptsave/*.c \
	   third_party/cmp/*.c)
toxcore_OBJECTS := $(toxcore_SOURCES:.c=.o)
$(toxcore_OBJECTS): CFLAGS += \
	-Werror \
	-D__COMPCERT__ \
	-DDISABLE_VLA \
	-DMIN_LOGGER_LEVEL=LOGGER_LEVEL_TRACE \
	-Dinline= \

send_message_test: $(libsodium_OBJECTS) $(toxcore_OBJECTS)
	$(CC) -o $@ $+ $(LDFLAGS)

=== other/docker/misra/Makefile ===
# See the following PDF for descriptions of each of the rules:
# http://my.ldrasoftware.co.uk/repository/miscellaneous/Misra-c_2012_compliance.pdf

# There should be no unused parameters in functions.
#
# Reason: callbacks often have unused parameters. Marking them explicitly isn't
# very helpful. A better diagnostic should be able to identify functions never
# used as callbacks and warn about unused parameters in those.
SUPPRESSIONS = 2.7
# The character sequences /* and // shall not be used within a comment.
#
# Reason: "//" appears in code examples and "http://" inside comments.
SUPPRESSIONS += 3.1
# Identifiers declared in the same scope and name space shall be distinct.
# Identifier not unique within 31 characters.
#
# Reason: Compilers we use allow longer identifier names.
SUPPRESSIONS += 5.2
# Macro identifiers shall be distinct.
# Identifier matches macro name in 31 chars.
#
# Reason: Compilers we use allow longer identifier names.
SUPPRESSIONS += 5.4
# The lowercase character 'l' shall not be used in a literal suffix.
#
# Reason: False positive. We don't use 'l', but this flags 'ulOutBufLen'.
SUPPRESSIONS += 7.3
# Operands shall not be of an inappropriate essential type.
#
# Reason: This diagnoses (1 << n) and wants us to use (1u << n). That's fair,
# but this diagnostic is impossible to fix for ((1u << n) >> m).
SUPPRESSIONS += 10.1
# Both operands of an operator in which the usual arithmetic conversions are performed shall have the same essential type category.
#
# Reason: This warns about ((unsigned)n == 0) and other constant comparisons.
SUPPRESSIONS += 10.4
# The value of a composite expression shall not be cast to a different essential type category or a wider essential type.
#
# TODO(iphydf): investigate.
SUPPRESSIONS += 10.8
# A conversion should not be performed from pointer to void into pointer to object.
#
# Reason: this is needed for generic callbacks to make any sense.
SUPPRESSIONS += 11.5
# A conversion shall not remove any const, volatile or _Atomic qualification from the type pointed to by a pointer.
#
# Reason: we need to cast from _Nullable to _Nonnull.
SUPPRESSIONS += 11.8
# The precedence of operators within expressions should be made explicit.
#
# Reason: this asks us to add a lot of extra parentheses that don't really help
# readability. We expect people to know basic precedence. GCC has a better
# diagnostic requiring parentheses around less common operators.
SUPPRESSIONS += 12.1
# The comma operator should not be used.
#
# Reason: We don't use the comma operator (cimple doesn't even parse it). This is
# all false positives.
SUPPRESSIONS += 12.3
# Evaluation of constant expressions should not lead to unsigned integer wrap-around.
#
# Reason: False positives on UINT64_MAX.
SUPPRESSIONS += 12.4
# A full expression containing an increment (++) or decrement (--) operator should have no other potential side effects other than that caused by the increment or decrement operator.
#
# TODO(iphydf): maybe fix?
SUPPRESSIONS += 13.3
# The controlling expression of an if statement and the controlling expression of an iteration-statement shall have essentially Boolean type.
#
# Reason: We actually follow this rule, but cppcheck's implementation is flawed and has false positives.
SUPPRESSIONS += 14.4
# The goto statement should not be used.
#
# TODO(iphydf): Get rid of goto.
SUPPRESSIONS += 15.1
# A function should have a single point of exit at the end.
#
# Reason: This doesn't make code much clearer. Sometimes this is useful for
# putting all the cleanup code in one spot, but often an early return improves
# readability.
SUPPRESSIONS += 15.5
# All if . . else if constructs shall be terminated with an else statement.
#
# TODO(iphydf): Why is this a good idea?
SUPPRESSIONS += 15.7
# An unconditional break statement shall terminate every switch-clause.
#
# Reason: This conflicts with "break unused after abort()". MISRA doesn't allow
# abort(), but we use it, so this rule must be disabled, too.
SUPPRESSIONS += 16.3
# Every switch statement shall have a default label.
#
# Reason: C compilers have better diagnostics for this (-Wswitch variants).
SUPPRESSIONS += 16.4
# The features of <stdarg.h> shall not be used.
#
# Reason: We use it for logging.
SUPPRESSIONS += 17.1
# Functions shall not call themselves, either directly or indirectly.
#
# Reason: Cimple is better at this diagnostic, recognising indirect recursion
# through callbacks.
SUPPRESSIONS += 17.2
# The value returned by a function having non-void return type shall be used.
#
# TODO(iphydf): Investigate.
SUPPRESSIONS += 17.7
# A function parameter should not be modified.
#
# TODO(iphydf): maybe fix?
SUPPRESSIONS += 17.8
# The +, -, += and -= operators should not be applied to an expression of pointer type.
# Use of pointer arithmetic.
#
# TODO(iphydf): Someday we won't be using pointer arithmetic.
SUPPRESSIONS += 18.4
# Flexible array members shall not be declared.
#
# TODO(iphydf): Fix.
SUPPRESSIONS += 18.7
# Variable-length array types shall not be used.
#
# TODO(iphydf): Fix.
SUPPRESSIONS += 18.8
# The union keyword should not be used.
#
# TODO(iphydf): Maybe we need a good linter to check that unions are used safely.
SUPPRESSIONS += 19.2
# #undef should not be used.
#
# Reason: We believe it should be used when #define is used in block scope.
SUPPRESSIONS += 20.5
# #define and #undef shall not be used on a reserved identifier or reserved macro name.
#
# Reason: Needed for feature test macros like _DEFAULT_SOURCE.
SUPPRESSIONS += 21.1
# The memory allocation and deallocation functions of <stdlib.h> shall not be used.
#
# Reason: We use malloc/free. Making our own allocators doesn't make the code
# safer.
SUPPRESSIONS += 21.3
# The Standard Library input/output routines shall not be used.
#
# Reason: Used in logging.
SUPPRESSIONS += 21.6
# The Standard Library termination functions of <stdlib.h> shall not be used.
# Use of abort, exit, etc.
#
# Reason: Used in LOGGER_FATAL.
SUPPRESSIONS += 21.8
# The Standard Library functions bsearch and qsort of <stdlib.h> shall not be used.
#
# TODO(iphydf): Why not use qsort?
SUPPRESSIONS += 21.9
# The Standard Library time and date routines shall not be used.
#
# TODO(iphydf): Probably stop using time().
SUPPRESSIONS += 21.10

CPPFLAGS := -DCMP_NO_FLOAT=1 -DMIN_LOGGER_LEVEL=LOGGER_LEVEL_TRACE

FIND_FLAGS := -name "*.c"								\
			  -and -not -wholename "*/auto_tests/*"		\
			  -and -not -wholename "*/other/*"			\
			  -and -not -wholename "*/super_donators/*"	\
			  -and -not -wholename "*/third_party/*"
SOURCES := $(shell find /src/workspace/c-toxcore $(FIND_FLAGS))

analyse: $(DUMPS:.dump=.diag)
	cppcheck --error-exitcode=1 -j8 --addon=misra --suppress=doubleFree $(patsubst %,--suppress=misra-c2012-%,$(SUPPRESSIONS)) $(CPPFLAGS) $(SOURCES)

=== other/docker/slimcc/Makefile ===
SOURCES		:= \
		   auto_tests/scenarios/framework/framework.c \
		   auto_tests/scenarios/scenario_send_message_test.c \
		   testing/misc_tools.c \
		   $(wildcard tox*/*.c tox*/*/*.c) \
		   third_party/cmp/cmp.c
OBJECTS		:= $(SOURCES:.c=.o)

CC		:= /work/slimcc/slimcc
CFLAGS		:= $(shell pkg-config --cflags libsodium opus vpx)
LDFLAGS		:= $(shell pkg-config --libs libsodium opus vpx)

send_message_test: $(OBJECTS)
	$(CC) -o $@ $+ $(LDFLAGS)

=== debian/changelog ===
libtoxcore (0.2.22-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.7.3

 -- Yangfl <mmyangfl@gmail.com>  Wed, 25 Feb 2026 04:37:48 +0800

=== debian/control ===
Source: libtoxcore
Section: libs
Maintainer: Yangfl <mmyangfl@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 pkgconf,
 libconfig-dev,
 libncurses-dev,
 libopus-dev,
 libsodium-dev,
 libvpx-dev,
Standards-Version: 4.7.3
Homepage: https://tox.chat
Vcs-Git: https://salsa.debian.org/yangfl-guest/c-toxcore.git
Vcs-Browser: https://salsa.debian.org/yangfl-guest/c-toxcore

Package: libtoxcore2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Distributed, secure messenger
 Tox provides an encrypted, distributed, and extensible peer-to-peer platform
 that can be used for various forms of communication. Tox is intended to be used
 as a multimedia messenger, but many people have shown that Tox can be used for
 a lot more than just instant messaging.

Package: libtoxcore-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 ${misc:Depends},
 libtoxcore2 (= ${binary:Version}),
 libsodium-dev,
 libopus-dev,
 libvpx-dev,
Description: Distributed, secure messenger - development headers
 Tox provides an encrypted, distributed, and extensible peer-to-peer platform
 that can be used for various forms of communication. Tox is intended to be used
 as a multimedia messenger, but many people have shown that Tox can be used for
 a lot more than just instant messaging.
 .
 This package contains the development headers.

Package: toxcore-utils
Architecture: any
Section: net
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Distributed, secure messenger - DHT bootstrap tools
 Tox provides an encrypted, distributed, and extensible peer-to-peer platform
 that can be used for various forms of communication. Tox is intended to be used
 as a multimedia messenger, but many people have shown that Tox can be used for
 a lot more than just instant messaging.
 .
 This package contains DHT bootstrap tools, including DHT_bootstrap and
 tox-bootstrapd.

=== debian/watch ===
Version: 5
Source: https://api.github.com/repos/TokTok/c-toxcore/releases?per_page=100
Matching-Pattern: https://github.com/[^/]+/[^/]+/releases/download/[^/]+/@ANY_VERSION@.tar.xz
Filename-Mangle: s/.*?@ANY_VERSION@(@ARCHIVE_EXT@)/@PACKAGE@-$1$2/
Uversion-Mangle: s/-rc\./~rc/
Search-Mode: plain
Pgp-Sig-Url-Mangle: s/$/.asc/
